#extension GL_OES_EGL_image_external:require
precision mediump float;
varying vec2 textureCoordinate;
uniform samplerExternalOES yuvTexSampler;
uniform int changeType;
varying vec4 aPos;
const int isHalf = int(0);
const highp vec4 gray = vec4(0.299,0.587,0.114,1.0);//warm
const highp vec4 warm = vec4(0.1,0.1,0.0,1.0);//warm
const highp vec4 blue = vec4(0.006,0.004,0.002,1.0);//warm
const highp vec4 cool = vec4(0.0,0.0,0.1,1.0);//cool

void modifyColor(vec4 color){
    color.r=max(min(color.r,1.0),0.0);
    color.g=max(min(color.g,1.0),0.0);
    color.b=max(min(color.b,1.0),0.0);
    color.a=max(min(color.a,1.0),0.0);
}

void main() {
    vec4 handlerColor = texture2D(yuvTexSampler, textureCoordinate);
    if(aPos.y > 0.0 || isHalf == 1){
       if(changeType == 1){
         float gray = gray.r*handlerColor.r+gray.g*handlerColor.g+gray.b*handlerColor.b;
         vec4 deltaColor = vec4(gray,gray,gray,handlerColor.a);
         modifyColor(deltaColor);
         gl_FragColor = deltaColor;
        }else if(changeType == 2){
                  vec4 deltaColor=handlerColor+vec4(warm);
                             modifyColor(deltaColor);
                             gl_FragColor=deltaColor;;
                 }else if(changeType == 3){
                       vec4 deltaColor=handlerColor+vec4(blue);
                                  modifyColor(deltaColor);
                                  gl_FragColor=deltaColor;;
                      }else if(changeType == 4){
                            vec4 deltaColor=handlerColor+vec4(cool);
                                       modifyColor(deltaColor);
                                       gl_FragColor=deltaColor;;
                           }else{
               gl_FragColor = handlerColor;
            }
    }else{
     gl_FragColor = handlerColor;
    }


}